package org.example.app_sb.controller;

import org.example.app_sb.entity.User;
import org.example.app_sb.service.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.DigestUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

@RestController
public class UserController {
    @Autowired
    private UserService userService;

    @GetMapping("/api/set_803")
    public String setUser(@RequestParam String name, @RequestParam String address) {
        return userService.setUser(name, address);
    }

    @GetMapping("/api/get_803")
    public String getUser(@RequestParam String name) {
        return userService.getUserAddress(name);
    }

    // 注册接口
    @GetMapping("/api/register_803_1")
    public String register2(
            @RequestParam String name,
            @RequestParam String password) {
        return userService.register(name, password);
    }

    @GetMapping("/api/register_803_2")
    public String register(
            @RequestParam String name,
            @RequestParam String password) {
        System.out.println("|***********register_803_2**************|");
        System.out.println(name + " " + password);
        System.out.println("|***********register_803_2**************|");
        return userService.register(name, password);
    }

    // 登录接口
    @GetMapping("/api/login_803_1")
        public String login(
            @RequestParam String name,
            @RequestParam String password) {
        return userService.login(name, password);
    }

    // 登录接口
//    @RequestMapping("login_803_2")
//    public String login_803_2(User user70Entity,
//                              HttpServletRequest httpServletRequest){
//        user70Entity.setPassword(DigestUtils.md5DigestAsHex(user70Entity.getPassword().getBytes()));
//        //开启session
//        HttpSession httpSession=httpServletRequest.getSession();
//
//        if(UserService.login(user70Entity)==1){
//            httpSession.setAttribute("name",user70Entity.getName());//$_SESSION['name']
//            return "登录成功";
//        }else{
//            httpSession.setAttribute("name","");
//            return "登录失败";
//        }
//    }
//    @GetMapping("/api/login_803_2")
//    public String login(
//            @RequestParam String name,
//            @RequestParam String password,
//            HttpSession session) {
//        System.out.println("|***********login_803_2**************|");
//        System.out.println(name + " " + password);
//        System.out.println(session.getAttribute("name"));
//        System.out.println("|***********login_803_2**************|");
//        if (userService.validateLogin(name, password)) {
//            session.setAttribute("name", name);
//            return "登录成功";
//        } else {
//            return "登录失败";
//        }
//    }
    @GetMapping("/api/login_803_2")
    public String login(
            @RequestParam String name,
            @RequestParam String password,
            HttpServletRequest httpServletRequest) {
        System.out.println("|***********login_803_2**************|");
        System.out.println(name + " " + password);
//        System.out.println(session.getAttribute("name"));
        System.out.println("|***********login_803_2**************|");
        //开启session
        HttpSession httpSession=httpServletRequest.getSession();

        if (userService.validateLogin(name, password)) {
            httpSession.setAttribute("name", name);
            return "登录成功";
        } else {
            httpSession.setAttribute("name","");
            return "登录失败";
        }
    }
    @RequestMapping("api/list_803_2")
    public String list_803_2(HttpServletRequest httpServletRequest){
        HttpSession httpSession=httpServletRequest.getSession();
        String returnValue="";
        try{
            returnValue=httpSession.getAttribute("name").toString();
            if (returnValue == "") {
                returnValue="未受权，请先登录";

            }

        }catch (Exception e){
            returnValue="未受权，请先登录";
        }
        return returnValue;
    }

    // 列表访问接口
//    @RequestMapping("/api/list_803_2")
//    public String list(@RequestParam String name, HttpSession session) {
//        String loggedInUser = (String) session.getAttribute("name");
//        System.out.println("|***********list_803_2**************|");
//        System.out.println(name + " " + session.getAttribute("name"));
//        System.out.println("|***********list_803_2**************|");
//        if (loggedInUser != null && loggedInUser.equals(name)) {
//            return loggedInUser;
//        } else {
//            return "未受权，请先登录";
//        }
//    }

}
